// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package gamelift provides the client and types for making API
// requests to Amazon GameLift.
//
// GameLift provides solutions for hosting session-based multiplayer game servers
// in the cloud, including tools for deploying, operating, and scaling game
// servers. Built on AWS global computing infrastructure, GameLift helps you
// deliver high-performance, high-reliability, low-cost game servers while dynamically
// scaling your resource usage to meet player demand.
//
// About GameLift solutions
//
// Get more information on these GameLift solutions in the GameLift Developer
// Guide (https://docs.aws.amazon.com/gamelift/latest/developerguide/).
//
//    * GameLift managed hosting -- GameLift offers a fully managed service
//    to set up and maintain computing machines for hosting, manage game session
//    and player session life cycle, and handle security, storage, and performance
//    tracking. You can use automatic scaling tools to balance player demand
//    and hosting costs, configure your game session management to minimize
//    player latency, and add FlexMatch for matchmaking.
//
//    * Managed hosting with Realtime Servers -- With GameLift Realtime Servers,
//    you can quickly configure and set up ready-to-go game servers for your
//    game. Realtime Servers provides a game server framework with core GameLift
//    infrastructure already built in. Then use the full range of GameLift managed
//    hosting features, including FlexMatch, for your game.
//
//    * GameLift FleetIQ -- Use GameLift FleetIQ as a standalone service while
//    hosting your games using EC2 instances and Auto Scaling groups. GameLift
//    FleetIQ provides optimizations for game hosting, including boosting the
//    viability of low-cost Spot Instances gaming. For a complete solution,
//    pair the GameLift FleetIQ and FlexMatch standalone services.
//
//    * GameLift FlexMatch -- Add matchmaking to your game hosting solution.
//    FlexMatch is a customizable matchmaking service for multiplayer games.
//    Use FlexMatch as integrated with GameLift managed hosting or incorporate
//    FlexMatch as a standalone service into your own hosting solution.
//
// About this API Reference
//
// This reference guide describes the low-level service API for Amazon GameLift.
// With each topic in this guide, you can find links to language-specific SDK
// guides and the AWS CLI reference. Useful links:
//
//    * GameLift API operations listed by tasks (https://docs.aws.amazon.com/gamelift/latest/developerguide/reference-awssdk.html)
//
//    * GameLift tools and resources (https://docs.aws.amazon.com/gamelift/latest/developerguide/gamelift-components.html)
//
// See https://docs.aws.amazon.com/goto/WebAPI/gamelift-2015-10-01 for more information on this service.
//
// See gamelift package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/
//
// Using the Client
//
// To contact Amazon GameLift with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon GameLift client GameLift for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/#New
package gamelift
